﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace IcsSetPosition_CS
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private int SetPos(int id, int pos)
    {
      byte[] tx = new byte[3]; // unsigned char tx[3]
      byte[] rx = new byte[6]; // unsigned char Rx[6](ループバックを含む)
      int dat;
      Boolean flag = true; // 正しくデータが受け取れたか

      tx[0] = (byte)(0x80 | id);       // CMD
      tx[1] = (byte)(pos >> 7 & 0x7F); // POS_H
      tx[2] = (byte)(pos & 0x7f);      // POS_L

      serialPort1.DiscardInBuffer();   // バッファをクリアする
      serialPort1.DiscardOutBuffer();

      serialPort1.Write(tx, 0, 3); // tx配列(ICSコマンド)をシリアルポートから出力する

      for (int i = 0; i < rx.Length; i++) // １バイト受信を６回繰り返す
      {
        try
        {
          rx[i] = (byte)serialPort1.ReadByte (); // １バイト受信
        }
        catch
        {
          flag = false; // 何かしら問題があって、受信が失敗
          break;
        }
      }

      if (flag == false) 
      {
        return -1;
      }

      dat = (int)rx[4]; // 受信したデータをポジションに戻す
      dat = (dat << 7) + (int)rx[5];

      return dat;
    }

    private void comboBox1_DropDown(object sender, EventArgs e)
    {
      comboBox1.Items.Clear();
      comboBox1.Items.AddRange(System.IO.Ports.SerialPort.GetPortNames());
    }

    private void button1_Click(object sender, EventArgs e)
    {
      serialPort1.Close(); // いったん閉じる
      if (comboBox1.Text != string.Empty) // ComboBoxでポート名が正しくセットされたとき
      {
        serialPort1.PortName = comboBox1.Text; // ポート名をセット
        serialPort1.Open ();                   // ポートを開く（接続する）
        if (serialPort1.IsOpen == true)        // ポートがきちんと開いたら
        {
          this.Text = this.Text + " [接続完了] "; // フォームのタイトルバーに[接続完了]と表示する
        }
      }
    }

    private void trackBar1_ValueChanged (object sender, EventArgs e)
    {
      if (serialPort1.IsOpen == true) // シリアルポートが接続済みか確認してから
      {
        // IDとポジションデータをSetPos関数へ送る
        int pos = SetPos ((int)numericUpDown1.Value, (int)trackBar1.Value); 
        if (pos != -1) // SetPos関数から返ってきたデータが正常だった場合
        {
          textBox1.Text = pos.ToString (); // テキストボックスに現在位置データを表示する
        }
      }
    }
  }
}
